package com.ibm.r2a.rules.rdj.examples.j2sebestpractices.synchronization;

public class WhileSleep_Example {

	public static void main( String[] args ){
		Lock lock = new Lock();
		final Consumer consumer = new Consumer( lock );
		final Producer producer = new Producer( lock );
    
		(new Thread( new Runnable() {
			public void run() {
				consumer.consume();
			}
		})).start();
    
    
		(new Thread( new Runnable() {
			public void run() {
				producer.produce();
			}
		})).start();
	}	
    
	public static final class Lock {
		public Lock() {
			super();
			lock();
		}
		public boolean isAvailable() {
			return available;
		}
		public void lock() {
			available = false;
		}
		public void unlock() {
			available = true;
		}
		private boolean available = false;
	}

	public static final class Consumer {
		public Consumer( Lock lock ) {
			this.lock = lock;
		}
  
		public void consume() {
			System.out.println( "Consumer: consume was called" ); //$NON-NLS-1$
			while ( !lock.isAvailable() ) {
				System.out.println( "Consumer: sleeping..." ); //$NON-NLS-1$
				try { Thread.sleep( 1000 ); } catch (InterruptedException e) {}
			}
			System.out.println( "Consumer: exiting" ); //$NON-NLS-1$
		}
    
		private Lock lock;
	}

	public static final class Producer {
		public Producer( Lock lock ) {
			this.lock = lock;
		}
		public void produce() {
			System.out.println( "Producer: produce was called" ); //$NON-NLS-1$
			try { Thread.sleep( 5000 ); } catch (InterruptedException e) {}
			System.out.println( "Producer: unlocking..." ); //$NON-NLS-1$
			lock.unlock();
			System.out.println( "Producer: exiting" ); //$NON-NLS-1$
		}
		private Lock lock;
	}

	    
}
